###################################################
### chunk number 1: foo
###################################################
#line 25 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
options(width = 60)
foo <- packageDescription("raster")


###################################################
### chunk number 2: raster-1a
###################################################
#line 84 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
library(raster)
# \RasterLayer with the default parameters
r <- raster()
r

# With other parameters
r <- raster(ncol=36, nrow=18, xmn=-1000, xmx=1000, ymn=-100, ymx=900)
# that can be changed
res(r)
res(r) <- 100
res(r)
ncol(r)
ncol(r) <- 18
ncol(r)
res(r)
projection(r) <- "+proj=utm +zone=48 +datum=WGS84"
r


###################################################
### chunk number 3: raster-1b
###################################################
#line 106 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
r <- raster(ncol=10, nrow=10)
ncell(r)
hasValues(r)
# use the 'values' function
values(r) <- runif(ncell(r))
hasValues(r)
inMemory(r)
values(r)[1:10]

plot(r, main='Raster with 100 cells')


###################################################
### chunk number 4: raster-1c
###################################################
#line 121 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
hasValues(r)
res(r)
dim(r)
xmax(r)
xmax <- 0
hasValues(r)
res(r)
dim(r)
xmax(r)
ncol(r) <- 6
hasValues(r)
res(r)
dim(r)
xmax(r)


###################################################
### chunk number 5: raster-2a
###################################################
#line 142 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
#get the name of an example file installed with the package
filename <- (system.file("external/test.grd", package="raster"))
filename
r <- raster(filename)
filename(r)
hasValues(r)
inMemory(r)
plot(r, main='RasterLayer from file')


###################################################
### chunk number 6: raster-2b
###################################################
#line 155 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
# create three identical RasterLayer objects
r1 <- r2 <- r3 <- raster(nrow=10, ncol=10)
# Assign random cell values 
values(r1) <- runif(ncell(r1))
values(r2) <- runif(ncell(r2))
values(r3) <- runif(ncell(r3))

# combine three RasterLayer objects into a RasterStack
s <- stack(r1, r2, r3)
s
nlayers(s)

# combine three RasterLayer objects into a RasterBrick 
b1 <- brick(r1, r2, r3)
# equivalent to:
b2 <- brick(s)

# create a RasterBrick  from file
b <- brick(system.file("external/rlogo.grd", package="raster"))
b
nlayers(b)

# extract a single RasterLayer
r <- raster(b, layer=2)
# equivalent to creating it from disk
r <- raster(system.file("external/rlogo.grd", package="raster"), band=2)


###################################################
### chunk number 7: raster-3a
###################################################
#line 189 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
r <- raster(ncol=10, nrow=10)
r[] <- 1:ncell(r)
s <- r + 10
s <- sqrt(s)
s <- s * r + 5
r[] <- runif(ncell(r))
r <- round(r)
r <- r == 1
s[r] <- -0.5
s[!r] <- 5
s[s == 5] <- 15


###################################################
### chunk number 8: raster-3b
###################################################
#line 208 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
r <- raster(ncol=5, nrow=5)
r[] <- 1
s <- stack(r, r+1)
q <- stack(r, r+2, r+4)
x <- r + s + q
x


###################################################
### chunk number 9: raster-3c
###################################################
#line 220 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
a <- mean(r,s,10)
b <- sum(r,s)
st <- stack(r, s, a, b)
sst <- sum(st)
sst


###################################################
### chunk number 10: raster-3d
###################################################
#line 229 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
cellStats(st, 'sum')
cellStats(sst, 'sum')


###################################################
### chunk number 11: raster-5
###################################################
#line 262 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
r <- raster()
r[] <- 1:ncell(r)
ra <- aggregate(r, 10)
r1 <- crop(r, extent(-180,0,0,30))
r2 <- crop(r, extent(-10,180,-20,10))
m <- merge(r1, r2, filename='test.grd', overwrite=TRUE)
plot(m)


###################################################
### chunk number 12: raster-6
###################################################
#line 284 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
r <- raster(ncol=5, nrow=1)
r[] <- 1:ncell(r)
getValues(r)
s <- calc(r, fun=function(x){ x[x < 4] <- NA; return(x)} )
as.matrix(s)
t <- overlay(r, s, fun=function(x, y){ x / (2 * sqrt(y)) + 5 } )
as.matrix(t)
u <- mask(r, t)
as.matrix(u)
v = u==s
as.matrix(v)
w <- cover(t, r)
as.matrix(w)
x <- reclass(w, c(0,2,1,  2,5,2, 4,10,3))
as.matrix(x)
y <- subs(x, data.frame(id=c(2,3), v=c(40,50)))
as.matrix(y)


###################################################
### chunk number 13: raster-7
###################################################
#line 336 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
r <- raster(ncol=36, nrow=18)
r[] <- runif(ncell(r))
cellStats(r, mean)
s = r
s[] <- round(runif(ncell(r)) * 5)
zonal(r,s,median)
freq(s)
count(s, 3)
crosstab(r*3, s)


###################################################
### chunk number 14: raster-20a
###################################################
#line 354 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
b <- brick(system.file("external/rlogo.grd", package="raster"))
plot(b)


###################################################
### chunk number 15: raster-20b
###################################################
#line 360 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
plotRGB(b, r=1, g=2, b=3)


###################################################
### chunk number 16: raster-8
###################################################
#line 382 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
library(raster)
r <- raster(ncol=36, nrow=18)
ncol(r)
nrow(r)
ncell(r)
rowFromCell(r, 100)
colFromCell(r, 100)
cellFromRowCol(r,5,5)
xyFromCell(r, 100)
cellFromXY(r, c(0,0))
colFromX(r, 0)
rowFromY(r, 0)


###################################################
### chunk number 17: raster-10
###################################################
#line 402 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
r <- raster(system.file("external/test.grd", package="raster"))
getValues(r, 50)[35:39]
getValuesBlock(r, 50, 1, 35, 5)


###################################################
### chunk number 18: raster-11
###################################################
#line 410 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
cells <- cellFromRowCol(r, 50, 35:39)
cells
extract(r, cells)
xy = xyFromCell(r, cells)
xy
extract(r, xy)


###################################################
### chunk number 19: raster-12
###################################################
#line 427 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
r[cells] 
r[1:4]
filename(r)
r[2:3] <- 10
r[1:4]
filename(r)


###################################################
### chunk number 20: raster-13
###################################################
#line 438 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
r[1]
r[2,2]
r[1,]
r[,1]
r[1:3,1:3]


###################################################
### chunk number 21: raster-20
###################################################
#line 461 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
r1 <- raster(ncol=36, nrow=18)
r2 <- r1
r1[] <- runif(ncell(r1))
r2[] <- runif(ncell(r1))
s <- stack(r1, r2)
sgdf <- as(s, 'SpatialGridDataFrame')
newr2 <- raster(sgdf, 2)
news <- stack(sgdf)


###################################################
### chunk number 22: raster-32
###################################################
#line 477 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
setClass ('myRaster',
	contains = 'RasterLayer',
	representation (
		important = 'data.frame',
		essential = 'character'
	) ,
	prototype (
		important = data.frame(),
		essential = ''
	)
)
	
r = raster(nrow=10, ncol=10)

m <- as(r, 'myRaster')
m@important <- data.frame(id=1:10, value=runif(10))
m@essential <- 'my own slot'
m[] <- 1:ncell(m)
plot(m)


###################################################
### chunk number 23: raster-33
###################################################
#line 499 "d:/Rcompile/CRANpkg/local/2.12/raster/inst/doc/Raster.Rnw"
setMethod ('show' , 'myRaster', 
	function(object) {
		callNextMethod(object) # call show(RasterLayer)
		cat('essential:', object@essential, '\n')
		cat('important information:\n')
		print( object@important)
	})	
	
m


